package ch.unige.aou.controller.admin;

import java.util.List;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.controller.ResourceController;
import ch.unige.solidify.security.NoOnePermissions;
import ch.unige.solidify.security.UserPermissions;

import ch.unige.aou.business.NotificationTypeService;
import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.notification.NotificationType;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.UrlPath;

@RestController
@NoOnePermissions
@ConditionalOnBean(AdminController.class)
@RequestMapping(UrlPath.ADMIN_NOTIFICATION_TYPES)
public class NotificationTypeController extends ResourceController<NotificationType> {

  @UserPermissions
  @GetMapping(SolidifyConstants.URL_SEP + AouActionName.LIST_NOTIFICATIONS_TYPES_MANDATORY)
  public HttpEntity<List<String>> listNotificationTypesMandatory() {
    return new ResponseEntity<>(((NotificationTypeService)this.itemService).getAllMandatoryNotificationTypes(), HttpStatus.OK);
  }

}
