package ch.unige.aou.controller.admin;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PatchMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.controller.ResourceController;
import ch.unige.solidify.rest.Collection;
import ch.unige.solidify.security.AdminPermissions;
import ch.unige.solidify.security.UserPermissions;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.PublicationType;
import ch.unige.aou.rest.UrlPath;

@AdminPermissions
@RestController
@ConditionalOnBean(AdminController.class)
@SuppressWarnings("squid:S4684")
@RequestMapping(UrlPath.ADMIN_PUBLICATION_TYPES)
public class PublicationTypeController extends ResourceController<PublicationType> {

  @Override
  @PostMapping
  public HttpEntity<PublicationType> create(@RequestBody PublicationType type) {
    return super.create(type);
  }

  @Override
  @DeleteMapping(SolidifyConstants.URL_ID)
  public HttpStatus delete(@PathVariable String id) {
    return super.delete(id);
  }

  @Override
  @DeleteMapping
  public HttpStatus deleteList(@RequestBody String[] ids) {
    return super.deleteList(ids);
  }

  @Override
  @PatchMapping(SolidifyConstants.URL_ID)
  public HttpEntity<PublicationType> update(@PathVariable String id, @RequestBody PublicationType type) {
    return super.update(id, type);
  }

  @Override
  @UserPermissions
  public HttpEntity<Collection<PublicationType>> list(@ModelAttribute PublicationType search, Pageable pageable) {
    return super.list(search, pageable);
  }

  @Override
  @UserPermissions
  public HttpEntity<PublicationType> get(@PathVariable String id) {
    return super.get(id);
  }
}
