package ch.unige.aou.service;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.stereotype.Service;

import ch.unige.solidify.auth.client.service.AuthorizationClientProperties;
import ch.unige.solidify.service.MessageService;

import ch.unige.aou.config.AouProperties;
import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.ModuleList;

@Service
@ConditionalOnBean(AdminController.class)
public class MonitorService extends AouService {

  private String adminModulePublicUrl;
  private String accessModulePublicUrl;
  private String authModulePublicUrl;

  public MonitorService(AouProperties aouProperties, AuthorizationClientProperties authClientProperties, MessageService messageService) {
    super(messageService);
    this.adminModulePublicUrl = aouProperties.getModule().getAdmin().getPublicUrl();
    this.accessModulePublicUrl = aouProperties.getModule().getAccess().getPublicUrl();
    this.authModulePublicUrl = authClientProperties.getPublicAuthorizationServerUrl();
  }

  public ModuleList getModuleUrls() {
    return new ModuleList(this.authModulePublicUrl, this.adminModulePublicUrl, this.accessModulePublicUrl);
  }
}
