package ch.unige.aou.service.admin;

import java.util.List;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.publication.PublicationSubtype;
import ch.unige.aou.model.publication.PublicationType;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.CompositionResourceClientService;

@Service
public class PublicationSubtypeCompositionClientService extends CompositionResourceClientService<PublicationType, PublicationSubtype>
        implements PublicationSubtypeCompositionClientServiceInterface {

  private static final String PUBLICATION_SUBTYPES_PATH =
          SolidifyConstants.URL_SEP + ResourceName.PUBLICATION_TYPES + SolidifyConstants.URL_PARENT_ID + ResourceName.PUBLICATION_SUBTYPES;

  public PublicationSubtypeCompositionClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(PUBLICATION_SUBTYPES_PATH, PublicationSubtype.class, ModuleName.ADMIN, restClientTool, env);
  }

  @Override
  public List<PublicationSubtype> findAll(String parentId) {
    return this.findAll(parentId, PublicationSubtype.class);
  }
}
