package ch.unige.aou.test.admin;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertNotNull;

import java.util.List;
import java.util.stream.Collectors;

import org.junit.jupiter.api.Test;

import ch.unige.aou.AouConstants;
import ch.unige.aou.model.settings.LabelDTO;
import ch.unige.aou.model.settings.LanguageDTO;

class LanguageAsUserIT extends AbstractAdminIT {

  @Test
  void findAllTest() {
    List<LanguageDTO> languages = this.languageService.listAll();
    assertNotNull(languages);
    assertFalse(languages.isEmpty());

    /**
     * French
     */
    LanguageDTO language = languages.stream().filter(lang -> lang.getCode().equals(AouConstants.LANG_CODE_FRENCH)).
            collect(Collectors.toList()).get(0);
    assertNotNull(language);

    String frenchLanguageName = language.getLabels().stream()
            .filter(languageLabel -> languageLabel.getLanguageCode().equals(AouConstants.LANG_CODE_FRENCH)).map(LabelDTO::getText)
            .collect(Collectors.toList()).get(0);
    assertNotNull(frenchLanguageName);
    assertEquals("Français", frenchLanguageName);

    String englishLanguageName = language.getLabels().stream()
            .filter(languageLabel -> languageLabel.getLanguageCode().equals(AouConstants.LANG_CODE_ENGLISH)).map(LabelDTO::getText)
            .collect(Collectors.toList()).get(0);
    assertNotNull(englishLanguageName);
    assertEquals("French", englishLanguageName);

    /**
     * English
     */
    language = languages.stream().filter(lang -> lang.getCode().equals(AouConstants.LANG_CODE_ENGLISH))
            .collect(Collectors.toList()).get(0);
    assertNotNull(language);

    frenchLanguageName = language.getLabels().stream()
            .filter(languageLabel -> languageLabel.getLanguageCode().equals(AouConstants.LANG_CODE_FRENCH)).map(LabelDTO::getText)
            .collect(Collectors.toList()).get(0);
    assertNotNull(frenchLanguageName);
    assertEquals("Anglais", frenchLanguageName);

    englishLanguageName = language.getLabels().stream()
            .filter(languageLabel -> languageLabel.getLanguageCode().equals(AouConstants.LANG_CODE_ENGLISH)).map(LabelDTO::getText)
            .collect(Collectors.toList()).get(0);
    assertNotNull(englishLanguageName);
    assertEquals("English", englishLanguageName);

    /**
     * German
     */
    language = languages.stream().filter(lang -> lang.getCode().equals(AouConstants.LANG_CODE_GERMAN))
            .collect(Collectors.toList()).get(0);
    assertNotNull(language);

    frenchLanguageName = language.getLabels().stream()
            .filter(languageLabel -> languageLabel.getLanguageCode().equals(AouConstants.LANG_CODE_FRENCH)).map(LabelDTO::getText)
            .collect(Collectors.toList()).get(0);
    assertNotNull(frenchLanguageName);
    assertEquals("Allemand", frenchLanguageName);

    englishLanguageName = language.getLabels().stream()
            .filter(languageLabel -> languageLabel.getLanguageCode().equals(AouConstants.LANG_CODE_ENGLISH))
            .map(LabelDTO::getText).collect(Collectors.toList()).get(0);
    assertNotNull(englishLanguageName);
    assertEquals("German", englishLanguageName);
  }

}
