package ch.unige.aou.model.settings;

import java.util.HashMap;
import java.util.Map;

public class ValueWithTranslations {
  private String value;
  private Map<String, String> translations = new HashMap<>();

  public ValueWithTranslations(String value) {
    this.value = value;
  }

  public String getValue() {
    return this.value;
  }

  public Map<String, String> getTranslations() {
    return this.translations;
  }

  public void addTranslation(String languageCode, String text) {
    this.translations.put(languageCode, text);
  }

  public String getTranslation(String languageCode) {
    if (this.translations.containsKey(languageCode)) {
      return this.translations.get(languageCode);
    } else {
      return null;
    }
  }
}
