package ch.unige.aou.model.xml.deposit.v2_3.deserializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.ObjectCodec;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonNode;

import ch.unige.aou.model.xml.deposit.AouStdDeserializer;
import ch.unige.aou.model.xml.deposit.v2_3.DateTypes;
import ch.unige.aou.model.xml.deposit.v2_3.DateWithType;

public class DateWithTypeDeserializer extends AouStdDeserializer<DateWithType> {

  private static final long serialVersionUID = 1164328364L;

  @Override
  public DateWithType deserialize(JsonParser parser, DeserializationContext context) throws IOException, JsonProcessingException {

    ObjectCodec codec = parser.getCodec();
    JsonNode jsonNode = codec.readTree(parser);

    DateWithType dateWithType = new DateWithType();

    boolean hasValue = false;

    JsonNode dateNode = jsonNode.get("date");
    if (this.nodeHasTextValue(dateNode)) {
      dateWithType.setContent(dateNode.textValue());
      hasValue = true;
    }

    JsonNode typeNode = jsonNode.get("type");
    if (this.nodeHasTextValue(typeNode)) {
      dateWithType.setType(DateTypes.valueOf(typeNode.textValue()));
      hasValue = true;
    }

    if (hasValue) {
      return dateWithType;
    } else {
      return null;
    }
  }
}
