package ch.unige.aou.model.xml.deposit.v2_3.deserializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.ObjectCodec;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ArrayNode;

import ch.unige.solidify.exception.SolidifyRuntimeException;

import ch.unige.aou.model.xml.deposit.AouStdDeserializer;
import ch.unige.aou.model.xml.deposit.v2_3.DateWithType;
import ch.unige.aou.model.xml.deposit.v2_3.Dates;

public class DatesDeserializer extends AouStdDeserializer<Dates> {

  private static final long serialVersionUID = 1164328364L;

  @Override
  public Dates deserialize(JsonParser parser, DeserializationContext context) throws IOException, JsonProcessingException {

    ObjectCodec codec = parser.getCodec();
    JsonNode jsonNode = codec.readTree(parser);

    if (jsonNode instanceof ArrayNode) {
      if (jsonNode.isEmpty()) {
        return null;
      }

      Dates dates = new Dates();
      for (JsonNode dateNode : jsonNode) {
        DateWithType dateWithType = codec.treeToValue(dateNode, DateWithType.class);
        dates.getDate().add(dateWithType);
      }
      return dates;

    } else {
      throw new SolidifyRuntimeException("dates is not an array");
    }
  }
}
