package ch.unige.aou.model.xml.deposit.v2_3.serializer;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;

import ch.unige.aou.model.xml.deposit.v2_3.Group;
import ch.unige.aou.model.xml.deposit.v2_3.Groups;

public class GroupsSerializer extends StdSerializer<Groups> {
  public GroupsSerializer() {
    this(null);
  }

  public GroupsSerializer(Class<Groups> t) {
    super(t);
  }

  @Override
  public void serialize(Groups value, JsonGenerator jgen, SerializerProvider provider) throws IOException, JsonProcessingException {
    List<String> listGroupResId = new ArrayList<>();
    for (Group group : value.getGroup()) {
      listGroupResId.add(group.getResId());
    }
    jgen.writeObject(listGroupResId);
  }
}
