package ch.unige.aou.model.xml.deposit.v2_4.deserializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.ObjectCodec;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ArrayNode;

import ch.unige.solidify.exception.SolidifyRuntimeException;

import ch.unige.aou.model.xml.deposit.AouStdDeserializer;
import ch.unige.aou.model.xml.deposit.v2_4.Group;
import ch.unige.aou.model.xml.deposit.v2_4.Groups;

public class GroupsDeserializer extends AouStdDeserializer<Groups> {

  private static final long serialVersionUID = 659865L;

  @Override
  public Groups deserialize(JsonParser parser, DeserializationContext context) throws IOException, JsonProcessingException {

    ObjectCodec codec = parser.getCodec();
    JsonNode jsonNode = codec.readTree(parser);

    if (jsonNode instanceof ArrayNode) {
      if (jsonNode.isEmpty()) {
        return null;
      }

      Groups groups = new Groups();

      jsonNode.forEach(groupNode -> {
        Group group = new Group();
        if (this.nodeHasTextValue(groupNode)) {
          group.setResId(groupNode.textValue());
        }
        groups.getGroup().add(group);
      });
      return groups;

    } else {
      throw new SolidifyRuntimeException("groups is not an array");
    }
  }
}
