package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.security.Role;

public class RoleSpecification extends SolidifySpecification<Role> {
  private static final long serialVersionUID = 4403171480167875268L;

  public RoleSpecification(Role role) {
    super(role);
  }

  @Override
  protected void completePredicatesList(Root<Role> root, CriteriaQuery<?> query, CriteriaBuilder builder, List<Predicate> predicatesList) {
    if (this.criteria.getName() != null) {
      predicatesList.add(builder.like(root.get("name"), "%" + this.criteria.getName() + "%"));
    }
  }
}
