package ch.unige.aou.business;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import ch.unige.solidify.auth.model.ApplicationRole;
import ch.unige.solidify.auth.model.AuthApplicationRole;
import ch.unige.solidify.model.SolidifyApplicationRole;

import ch.unige.aou.repository.ApplicationRoleRepository;
import ch.unige.aou.specification.AouApplicationRoleSpecification;

@Service
public class ApplicationRoleService extends AouResourceService<SolidifyApplicationRole> {
  Logger log = LoggerFactory.getLogger(ApplicationRoleService.class);

  private ApplicationRoleRepository applicationRoleRepository;

  public ApplicationRoleService(ApplicationRoleRepository applicationRoleRepository) {
    this.applicationRoleRepository = applicationRoleRepository;
  }

  @Override
  public AouApplicationRoleSpecification getSpecification(SolidifyApplicationRole resource) {
    return new AouApplicationRoleSpecification(resource);
  }

  public void initDefaultData() {
    for (ApplicationRole role : AuthApplicationRole.getApplicationRoleList()) {
      if (!this.applicationRoleRepository.findById(role.getResId()).isPresent()) {
        SolidifyApplicationRole applicationRole = new SolidifyApplicationRole(role);
        this.save(applicationRole);
        this.log.info("Application Role '{}' created with level {}", role.getResId(), role.getLevel());
      }
    }
  }
}
