package ch.unige.aou.business;

import org.springframework.context.annotation.Profile;
import org.springframework.security.core.Authentication;
import org.springframework.stereotype.Service;

import ch.unige.aou.config.AouProperties;

@Profile({ "test", "sec-noauth" })
@Service
public class AuthenticatedUserTest implements AuthenticatedUserProvider {

  private String userId;

  public AuthenticatedUserTest(AouProperties aouProperties) {
    // personIds are the same as user names when test users and test people are generated in AdminController
    this.userId = aouProperties.getTest().getUsers().get(0).getName();
  }

  @Override
  public String getPersonId(Authentication authentication) {
    return this.userId;
  }
}
