package ch.unige.aou.repository;

import java.util.List;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import ch.unige.aou.AouConstants;
import ch.unige.aou.model.StatusHistory;


public interface HistoryRepository extends PagingAndSortingRepository<StatusHistory, Long> {

  // *************
  // ** Queries **
  // *************

  public List<StatusHistory> findByResId(@Param(AouConstants.DB_RES_ID) String resId);

  public Page<StatusHistory> findByResId(@Param(AouConstants.DB_RES_ID) String resId, Pageable pageable);

  @Query("SELECT s FROM StatusHistory s WHERE s.resId = :" + AouConstants.DB_RES_ID + " ORDER BY s.changeTime DESC")
  public List<StatusHistory> findStatusHistoryOrderByLastDate(@Param(AouConstants.DB_RES_ID) String resId);

  // ***************
  // ** Relations **
  // ***************

}
