package ch.unige.aou.repository;

import java.util.List;
import java.util.Optional;

import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import ch.unige.aou.model.publication.PublicationSubSubtype;
import ch.unige.aou.model.publication.PublicationSubtype;

import ch.unige.solidify.repository.SolidifyRepository;

@Repository
public interface PublicationSubSubtypeRepository extends SolidifyRepository<PublicationSubSubtype> {
  PublicationSubSubtype findByName(String name);

  PublicationSubSubtype findByNameAndPublicationSubtype(String name, PublicationSubtype subtype);

  @Query(value = "SELECT max(psst.sortValue) FROM PublicationSubSubtype psst WHERE psst.publicationSubtype.resId = :publicationSubtypeId")
  Optional<Integer> findMaxSortValueByPublicationSubtype(String publicationSubtypeId);

  @Query(value = "SELECT psst FROM PublicationSubSubtype psst WHERE psst.publicationSubtype.resId = :publicationSubtypeId")
  List<PublicationSubSubtype> findByPublicationSubtypes(String publicationSubtypeId);
}
