package ch.unige.aou.task;

import java.time.OffsetDateTime;
import java.time.ZoneOffset;

import ch.unige.aou.business.NotificationService;
import ch.unige.aou.business.ScheduledTaskService;
import ch.unige.aou.model.schedule.ScheduledTask;

public class SynchronizeResearchGroupsTask extends AbstractTaskRunnable {

  public SynchronizeResearchGroupsTask(ScheduledTaskService scheduledTaskService, ScheduledTask scheduledTask,
          NotificationService notificationService, TaskExecutorService taskExecutorService) {
    super(scheduledTaskService, scheduledTask, notificationService, taskExecutorService);
  }

  @Override
  protected void executeTask() {

    // always check the whole list as it will run once a day and does not take long to execute
    OffsetDateTime searchFrom = OffsetDateTime.of(2000, 1, 1, 0, 0, 0, 0, ZoneOffset.UTC);

    this.taskExecutorService.synchronizeFromUnigeReferential(searchFrom.toLocalDateTime());
  }
}
