package ch.unige.aou.controller;

import org.springframework.boot.autoconfigure.condition.ConditionalOnExpression;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.controller.ModuleController;
import ch.unige.solidify.exception.SolidifyRuntimeException;

import ch.unige.aou.business.ApplicationRoleService;
import ch.unige.aou.config.AouProperties;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.UrlPath;

@RestController
@ConditionalOnExpression("'${aou.module.auth.enable:false}' == 'false'")
@RequestMapping(UrlPath.RES_SRV)
public class ResourceSrvController extends ModuleController {

  ResourceSrvController(AouProperties aouProperties, ApplicationRoleService applicationRoleService) {
    super(ModuleName.RES_SRV);
    // Module initialization
    if (aouProperties.getData().isInit()) {
      try {
        applicationRoleService.initDefaultData();
      } catch (final Exception e) {
        throw new SolidifyRuntimeException(e.getMessage());
      }
    }
  }
}
