package ch.unige.aou.test.resource;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.springframework.restdocs.payload.FieldDescriptor;

import ch.unige.solidify.rest.ActionName;
import ch.unige.solidify.test.helper.AbstractResourceDoc;
import ch.unige.solidify.test.helper.FieldDescriptorBuilder;
import ch.unige.solidify.test.model.TypeField;

import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.rest.UrlPath;

public class DocumentFileTypeDoc extends AbstractResourceDoc {

  @Override
  public List<String> getListLinks() { return Collections.emptyList(); }

  @Override
  public String getName() {
    return UrlPath.ADMIN_DOCUMENT_FILE_TYPES;
  }

  @Override
  public List<String> getResourceLinks() {
    return Collections.emptyList();
  }

  @Override
  protected List<FieldDescriptor> getDocumentationFields() {
    // @formatter:off
    return Arrays.asList(
            new FieldDescriptorBuilder(this)
                    .name("value")
                    .description("The value of the document file")
                    .mandatory(true)
                    .type(TypeField.STRING)
                    .build(),
            new FieldDescriptorBuilder(this)
                    .name("labels")
                    .description("Translations of the document file type")
                    .mandatory(true)
                    .type(TypeField.ARRAY)
                    .build());
    // @formatter:on
  }
}
