package ch.unige.aou.test.resource;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.springframework.restdocs.payload.FieldDescriptor;

import ch.unige.solidify.test.helper.AbstractResourceDoc;
import ch.unige.solidify.test.helper.FieldDescriptorBuilder;
import ch.unige.solidify.test.model.TypeField;

import ch.unige.aou.rest.UrlPath;

public class LanguageDoc extends AbstractResourceDoc {

  @Override
  public List<String> getListLinks() {
    return Collections.emptyList();
  }

  @Override
  public String getName() {
    return UrlPath.ADMIN_LANGUAGES;
  }

  @Override
  public List<String> getResourceLinks() {
    return Collections.emptyList();
  }

  @Override
  protected List<FieldDescriptor> getDocumentationFields() {
    // @formatter:off
    return Arrays.asList(
      new FieldDescriptorBuilder(this)
        .name("code")
        .description("The code of the language")
        .mandatory(true)
        .type(TypeField.STRING)
        .customConstraints(CONSTRAINT_CODE_ISO)
        .testValue(TEST_CODE_ISO)
      .build(),
      new FieldDescriptorBuilder(this)
        .name("sortValue")
        .description("The sort value of the language")
        .mandatory(true)
        .type(TypeField.INT32)
        .testValue("10")
        .build(),
      new FieldDescriptorBuilder(this)
        .name("labels")
        .description("Translations of the language")
        .mandatory(false)
        .type(TypeField.ARRAY)
        .build());
    // @formatter:on
  }

}
